"""Validators and Validator-Generators"""


def vmstat_validator(vmstat_code):
    """Creates a vmStat(code) validator function.

    Args:
        vmstat_code (int): vmStat code

    Returns:
        A validator function which checks that the result matches the code
    """

    def validator(tup):
        try:
            (word, d) = tup
            code = word & 0xFF
            return code == vmstat_code
        except:
            return False

    return validator
